=== debian/changelog ===
containerd-stable (2.1.3-0ubuntu1) questing; urgency=medium

  * Fork from containerd-app (LP: #2120949)
    - Update package name
    - Add Conflics, Replaces, and Provides relations with containerd
    - Update package description
    - Depends on runc-stable instead of runc

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Tue, 26 Aug 2025 10:35:27 -0300
