=== debian/control ===
Source: containerd-stable
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               dh-golang,
               go-md2man,
               golang-1.24-go,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libseccomp-dev,
               pkgconf,
               procps
Standards-Version: 4.7.2
Homepage: https://containerd.io
Vcs-Git: https://github.com/canonical/containerd-stable.git
Vcs-Browser: https://github.com/canonical/containerd-stable

Package: containerd-stable
Architecture: linux-any
Depends: runc-stable, ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<< 19.03.13-0ubuntu4)
Conflicts: containerd
Replaces: containerd
Provides: containerd
Built-Using: ${misc:Built-Using}
Description: daemon to control runC
 Containerd is a daemon to control runC, built for performance and density.
 Containerd leverages runC's advanced features such as seccomp and user
 namespace support as well as checkpoint and restore for cloning and live
 migration of containers.
 .
 This package contains the binaries.
 .
 This is the stable version of Containerd in Ubuntu. This package will only
 receive updates for patch releases and security fixes. If you want to get
 feature updates, use containerd instead.
