## containerd-stable 2.1.5

=== debian/changelog ===
containerd-stable (2.1.5-0ubuntu1) resolute; urgency=medium

  * d/watch: use Github API to access older releases
  * New upstream version 2.1.5

 -- Athos Ribeiro <athos@ubuntu.com>  Wed, 17 Dec 2025 10:10:36 -0300
