=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/containerd-$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|preview)\.?\d*)$/$1~$2/,\
dversionmangle=s/[~+]ds\d*$//,\
searchmode=plain \
  https://api.github.com/repos/containerd/containerd/releases?per_page=50 \
  https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
